Attribute VB_Name = "mCheck"
'--------------------------------------------------
' E-Mail Checker
' By H G Laughland
'
' Checking Module
' General declarations and procedures.
'--------------------------------------------------

Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" (lpRasConn As Any, lpcb As Long, lpcConnections As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Const RAS_RASCONNSIZE = 412
Const RAS_MAXENTRYNAME = 256
Const RAS_MAXDEVICETYPE = 16
Const RAS_MAXDEVICENAME = 128

Public Const SND_FILENAME = &H20000     '  name is a file name
Public Const SND_SYNC = &H0         '  play synchronously (default)

Private Type RasConn
 dwSize As Long
 hRasConn As Long
 szEntryName(RAS_MAXENTRYNAME) As Byte
 szDeviceType(RAS_MAXDEVICETYPE) As Byte
 szDeviceName(RAS_MAXDEVICENAME) As Byte
End Type

Public Type MailAccount
 tUserName As String
 tPassword As String
 tServer As String
End Type

Public arServers() As MailAccount 'Holds the server list while program is active
Public iServerCount As Integer 'Holds current server total.
Public lInterval As Long 'Holds the interval between checks.

Public Sub ArrayLoad(strItem As String)
'Load data into an array element.
 iServerCount = iServerCount + 1
 ReDim Preserve arServers(iServerCount)
 arTemp = Split(strItem, "^", 3)
 arServers(iServerCount - 1).tServer = arTemp(0)
 arServers(iServerCount - 1).tUserName = arTemp(1)
 arServers(iServerCount - 1).tPassword = arTemp(2)
End Sub

Public Sub CheckConnection()
'Checks if user is connected to the net.
Dim rasBind As RasConn
Dim lSize As Long, lReply As Long
 rasBind.dwSize = 412
 lSize = rasBind.dwSize
 If RasEnumConnections(rasBind, lSize, lReply) = 0 And lReply = 0 Then
  MsgBox ("You are not connected to the net.")
  End
 End If
End Sub

Public Function ChooseFile(iType As Integer, cdTemp As CommonDialog) As String
'Common dialogue display.
Dim strFile As String
 cdTemp.Filter = "All Files (*.*)|*.*|TXT Files (*.txt)|*.txt"
 cdTemp.FilterIndex = 2
 Select Case iType
 Case 1 'Show openfile dialogue
  cdTemp.ShowOpen
 Case 2 'Show savefile dialogue
  cdTemp.ShowSave
 End Select
 ChooseFile = cdTemp.FileName
End Function

Function GetReg(hInKey As Long, ByVal subkey As String, ByVal valname As String)
  Dim RetVal As String, hSubKey As Long, dwType As Long
  Dim SZ As Long, v As String, r As Long
  RetVal = ""
  r = RegOpenKeyEx(hInKey, subkey, 0, 983139, hSubKey)
  If r <> 0 Then GoTo Ender
  SZ = 256: v = String(SZ, 0)
  r = RegQueryValueEx(hSubKey, valname, 0, dwType, ByVal v, SZ)
  If r = 0 And dwType = 1 Then
   RetVal = Left(v$, SZ - 1)
  Else
   RetVal = ""
  End If
  If hInKey = 0 Then r = RegCloseKey(hSubKey)
Ender:
  GetReg = RetVal
End Function

Private Function GetClient() As String
 Static strFolder As String, strKey As String
 strKey = "Software\Clients\Mail\"
 strResult = GetReg(&H80000002, strKey, "")
 strKey = strKey & strResult & "\Shell\Open\Command\"
 GetClient = GetReg(&H80000002, strKey, "")
End Function

Public Sub Main()
 CheckConnection
 Load frmMain
 lInterval = 300000
 If Not Dir(App.Path & "\Data.emc") = "" Then
  ReadData
  frmMain.StartTimer
 Else
  frmSetUp.Show
 End If
End Sub

Public Sub ReadData()
'Read ata from the file.
 Dim strFile As String, strData As String
 Dim iHandle As Integer 'File handle
 strFile = App.Path & "\Data.emc"
 iHandle = FreeFile
 Open strFile For Input As #iHandle
 Do While Not EOF(iHandle)
  Line Input #iHandle, strData
  strData = BinaryToText(strData)
  ArrayLoad strData
 Loop
 Close #iHandle
End Sub

Public Sub RunMail()
Dim strTemp As String
 strTemp = GetClient
 Shell strTemp, vbNormalFocus
End Sub

Public Sub SaveFile()
'Save Data To File
Dim F As Integer, x As Integer
Dim response As Integer, strTemp As String, strFile As String
On Error GoTo CloseError
If Not iServerCount > 0 Then Exit Sub
 strFile = App.Path & "\Data.emc"
 F = FreeFile
 Open strFile For Output As F
 For x = 0 To iServerCount - 1
  strTemp = arServers(x).tServer & "^" & arServers(x).tUserName & "^" & arServers(x).tPassword
  strTemp = TextToBinary(strTemp)
  Print #F, strTemp
 Next
 Close F
 Exit Sub
CloseError:
 MsgBox "Error occurred while trying to close file, please retry.", 48
End Sub

Public Sub TimerProc(ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
 frmMain.TimerAction
End Sub


